
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.agent.managers.compart_process_manager &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../../" src="../../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" />
   
  <link rel="stylesheet" href="../../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.agent.managers.compart_process_manager</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">.. module:: emulsion.agent.managers.functions</span>

<span class="sd">.. moduleauthor:: Sébastien Picault &lt;sebastien.picault@inra.fr&gt;</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>

<span class="kn">import</span> <span class="nn">itertools</span>                 <span class="k">as</span> <span class="nn">it</span>
<span class="kn">from</span>   <span class="nn">collections</span>               <span class="k">import</span> <span class="n">OrderedDict</span>

<span class="kn">import</span> <span class="nn">numpy</span>                     <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span>                    <span class="k">as</span> <span class="nn">pd</span>

<span class="kn">from</span>   <span class="nn">emulsion.agent.comparts</span>   <span class="k">import</span> <span class="n">Compartment</span>

<span class="kn">from</span>   <span class="nn">emulsion.agent.managers.group_manager</span>  <span class="k">import</span>  <span class="n">GroupManager</span>
<span class="kn">from</span>   <span class="nn">emulsion.agent.managers.abstract_process_manager</span>  <span class="k">import</span>  <span class="n">AbstractProcessManager</span>
<span class="kn">from</span>   <span class="nn">emulsion.agent.exceptions</span> <span class="k">import</span> <span class="n">StateVarNotFoundException</span>

<span class="c1">#   _____                                 _   _____</span>
<span class="c1">#  / ____|                               | | |  __ \</span>
<span class="c1"># | |     ___  _ __ ___  _ __   __ _ _ __| |_| |__) | __ ___   ___ ___  ___ ___</span>
<span class="c1"># | |    / _ \| &#39;_ ` _ \| &#39;_ \ / _` | &#39;__| __|  ___/ &#39;__/ _ \ / __/ _ \/ __/ __|</span>
<span class="c1"># | |___| (_) | | | | | | |_) | (_| | |  | |_| |   | | | (_) | (_|  __/\__ \__ \</span>
<span class="c1">#  \_____\___/|_| |_| |_| .__/ \__,_|_|   \__|_|   |_|  \___/ \___\___||___/___/</span>
<span class="c1">#                       | |</span>
<span class="c1">#                       |_|</span>
<span class="c1">#  __  __</span>
<span class="c1"># |  \/  |</span>
<span class="c1"># | \  / | __ _ _ __   __ _  __ _  ___ _ __</span>
<span class="c1"># | |\/| |/ _` | &#39;_ \ / _` |/ _` |/ _ \ &#39;__|</span>
<span class="c1"># | |  | | (_| | | | | (_| | (_| |  __/ |</span>
<span class="c1"># |_|  |_|\__,_|_| |_|\__,_|\__, |\___|_|</span>
<span class="c1">#                            __/ |</span>
<span class="c1">#                           |___/</span>

<div class="viewcode-block" id="CompartProcessManager"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager">[docs]</a><span class="k">class</span> <span class="nc">CompartProcessManager</span><span class="p">(</span><span class="n">AbstractProcessManager</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;A CompartProcessManager is aimed handling several independent</span>
<span class="sd">    StructuredViews at the same time, for managing true compartments.</span>
<span class="sd">    It can automatically allocate compartments for state machines</span>
<span class="sd">    associated with a specific state variable or attribute.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="CompartProcessManager.add_compart_process"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.add_compart_process">[docs]</a>    <span class="k">def</span> <span class="nf">add_compart_process</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span>
                            <span class="n">process_name</span><span class="p">,</span>
                            <span class="n">key_variables</span><span class="p">,</span>
                            <span class="n">compart_manager</span><span class="o">=</span><span class="p">(</span><span class="n">GroupManager</span><span class="p">,</span> <span class="p">{}),</span>
                            <span class="n">machine_name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                            <span class="n">compart_class</span><span class="o">=</span><span class="p">(</span><span class="n">Compartment</span><span class="p">,</span> <span class="p">{})):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="n">add_compart_process</span><span class="p">(</span><span class="n">process_name</span><span class="p">,</span> <span class="n">key_variables</span><span class="p">,</span>
                                    <span class="n">compart_manager</span><span class="o">=</span><span class="n">compart_manager</span><span class="p">,</span>
                                    <span class="n">machine_name</span><span class="o">=</span><span class="n">machine_name</span><span class="p">,</span>
                                    <span class="n">compart_class</span><span class="o">=</span><span class="n">compart_class</span><span class="p">)</span></div>

<div class="viewcode-block" id="CompartProcessManager.add_host"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.add_host">[docs]</a>    <span class="k">def</span> <span class="nf">add_host</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">host</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified host to the current Multiprocessmanager, associated</span>
<span class="sd">        with the specified key.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">_host</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_host</span> <span class="o">=</span> <span class="n">OrderedDict</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_host</span><span class="p">[</span><span class="n">host</span><span class="o">.</span><span class="n">keys</span><span class="p">]</span> <span class="o">=</span> <span class="n">host</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simulation</span> <span class="o">=</span> <span class="n">host</span><span class="o">.</span><span class="n">simulation</span>
        <span class="c1">## ADDED to correct bug when adding populations during running simulation</span>
        <span class="c1">## TODO: check if same problem with other paradigms AND if other statevars to update</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span> <span class="o">=</span> <span class="n">host</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span>
        <span class="c1">## TODO: other problem : the lines below update the step in</span>
        <span class="c1">## the group managers associated to the processes, but the</span>
        <span class="c1">## step in the counts is already 0 (in the steps after, OK) =&gt;</span>
        <span class="c1">## see the order between step assignation and count update</span>
        <span class="c1"># print(&quot;Adding host&quot;, host, &quot;to&quot;, self)</span>
        <span class="k">for</span> <span class="n">proc</span><span class="p">,</span> <span class="n">comp</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">proc</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                <span class="n">comp</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span></div>
                <span class="c1"># print(comp.statevars.step)</span>
        <span class="c1"># print(&quot;host step:&quot;, host.statevars.step, &quot; / my step&quot;, self.statevars.step)</span>

<div class="viewcode-block" id="CompartProcessManager.apply_initial_conditions"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.apply_initial_conditions">[docs]</a>    <span class="k">def</span> <span class="nf">apply_initial_conditions</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Initialize level with initial conditions specified in the model.</span>

<span class="sd">        As this agent is aimed at managing aggregated populations in</span>
<span class="sd">        the sub-levels, only &#39;populations&#39; are taken into account to</span>
<span class="sd">        initialize the sub-levels.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># print(self.keys)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">level</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">initial_conditions</span><span class="p">:</span>
            <span class="n">conds</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">initial_conditions</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">level</span><span class="p">]</span>
            <span class="n">total</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_model_value</span><span class="p">(</span><span class="n">conds</span><span class="p">[</span><span class="s1">&#39;total&#39;</span><span class="p">])</span> <span class="k">if</span> <span class="s1">&#39;total&#39;</span> <span class="ow">in</span> <span class="n">conds</span> <span class="k">else</span> <span class="mi">0</span>
            <span class="n">population_to_add</span> <span class="o">=</span> <span class="p">{}</span>
            <span class="c1"># print(conds)</span>
            <span class="k">for</span> <span class="n">proc</span><span class="p">,</span> <span class="n">compart</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">if</span> <span class="n">proc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                    <span class="k">continue</span>
                <span class="c1">## assuming here that in compartment-based models all</span>
                <span class="c1">## keys are based on enumerations</span>

                <span class="c1">## build the combinations of all possible compartment</span>
                <span class="c1">## keys (excluding autoremove states)</span>
                <span class="n">combinations</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">it</span><span class="o">.</span><span class="n">product</span><span class="p">(</span><span class="o">*</span><span class="p">[[</span><span class="n">state</span>
                                                  <span class="k">for</span> <span class="n">state</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">state_machines</span><span class="p">[</span><span class="n">machine_name</span><span class="p">]</span><span class="o">.</span><span class="n">states</span>
                                                  <span class="k">if</span> <span class="ow">not</span> <span class="n">state</span><span class="o">.</span><span class="n">autoremove</span><span class="p">]</span>
                                                 <span class="k">for</span> <span class="n">machine_name</span> <span class="ow">in</span> <span class="n">compart</span><span class="o">.</span><span class="n">keys</span><span class="p">]))</span>
                <span class="c1"># population_to_add[proc] = { key: 0 for key in combinations }</span>
                <span class="n">population_to_add</span><span class="p">[</span><span class="n">proc</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
                <span class="n">subtotal</span> <span class="o">=</span> <span class="mi">0</span>
                <span class="c1"># compute initial values for each group</span>
                <span class="k">for</span> <span class="n">state_names</span><span class="p">,</span> <span class="n">qty</span> <span class="ow">in</span> <span class="n">conds</span><span class="p">[</span><span class="s1">&#39;populations&#39;</span><span class="p">]:</span>
                    <span class="n">key</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">get_model_value</span><span class="p">(</span><span class="n">state_name</span><span class="p">)</span> <span class="k">for</span> <span class="n">state_name</span> <span class="ow">in</span> <span class="n">state_names</span><span class="p">)</span>
                    <span class="c1"># if key in population_to_add[proc]:</span>
                    <span class="k">if</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">combinations</span><span class="p">:</span>
                        <span class="n">amount</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_model_value</span><span class="p">(</span><span class="n">qty</span><span class="p">)</span>
                        <span class="n">population_to_add</span><span class="p">[</span><span class="n">proc</span><span class="p">][</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">amount</span>
                        <span class="n">subtotal</span> <span class="o">+=</span> <span class="n">amount</span>

                <span class="n">total</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">total</span><span class="p">,</span> <span class="n">subtotal</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">complement_population</span><span class="p">(</span><span class="n">population_to_add</span><span class="p">,</span> <span class="n">total</span><span class="o">=</span><span class="n">total</span><span class="p">)</span>
            <span class="c1"># print(population_to_add)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">add_population</span><span class="p">(</span><span class="n">population_to_add</span><span class="p">,</span> <span class="n">init</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">proc</span><span class="p">,</span> <span class="n">compart</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">if</span> <span class="n">proc</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                    <span class="n">compart</span><span class="o">.</span><span class="n">update_counts</span><span class="p">()</span></div>

<div class="viewcode-block" id="CompartProcessManager.add_new_population"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.add_new_population">[docs]</a>    <span class="k">def</span> <span class="nf">add_new_population</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">process_name</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="n">to_add</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">target_state</span><span class="p">,</span> <span class="n">amount</span><span class="p">,</span> <span class="n">_</span> <span class="ow">in</span> <span class="n">population</span><span class="p">:</span>
            <span class="n">key</span> <span class="o">=</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">get_model_value</span><span class="p">(</span><span class="n">target_state</span><span class="p">),)</span>
            <span class="k">if</span> <span class="n">key</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">to_add</span> <span class="ow">and</span> <span class="n">amount</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">to_add</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">amount</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">to_add</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">+=</span> <span class="n">amount</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_population</span><span class="p">({</span><span class="n">process_name</span><span class="p">:</span> <span class="n">to_add</span><span class="p">})</span></div>


<div class="viewcode-block" id="CompartProcessManager.complement_population"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.complement_population">[docs]</a>    <span class="k">def</span> <span class="nf">complement_population</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population_to_change</span><span class="p">,</span> <span class="n">total</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">remove</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Modifiy the population spec in a consistent way. Check is all</span>
<span class="sd">        populations in each process sum to the same total. If not, distribute</span>
<span class="sd">        the difference between total and sum at random between all available</span>
<span class="sd">        groups (FAIL if no available groups).</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1">## complement keys</span>
        <span class="k">for</span> <span class="n">proc</span><span class="p">,</span> <span class="n">compart</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">proc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                <span class="k">continue</span>
            <span class="c1">## assuming here that in compartment-based models all</span>
            <span class="c1">## keys are based on enumerations</span>

            <span class="c1">## build the combinations of all possible compartment</span>
            <span class="c1">## keys (excluding autoremove states)</span>
            <span class="k">if</span> <span class="n">remove</span><span class="p">:</span>
                <span class="n">combinations</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span>
                    <span class="n">it</span><span class="o">.</span><span class="n">product</span><span class="p">(</span><span class="o">*</span><span class="p">[[</span><span class="n">state</span>
                                  <span class="k">for</span> <span class="n">state</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">state_machines</span><span class="p">[</span><span class="n">machine_name</span><span class="p">]</span><span class="o">.</span><span class="n">states</span>
                                  <span class="k">if</span> <span class="ow">not</span> <span class="n">state</span><span class="o">.</span><span class="n">autoremove</span><span class="p">]</span>
                                 <span class="k">for</span> <span class="n">machine_name</span> <span class="ow">in</span> <span class="n">compart</span><span class="o">.</span><span class="n">keys</span><span class="p">]))</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">combinations</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span>
                    <span class="n">it</span><span class="o">.</span><span class="n">product</span><span class="p">(</span><span class="o">*</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">state_machines</span><span class="p">[</span><span class="n">machine_name</span><span class="p">]</span><span class="o">.</span><span class="n">states</span><span class="o">.</span><span class="n">available</span>
                                 <span class="k">for</span> <span class="n">machine_name</span> <span class="ow">in</span> <span class="n">compart</span><span class="o">.</span><span class="n">keys</span><span class="p">]))</span>
            <span class="k">if</span> <span class="n">proc</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">population_to_change</span><span class="p">:</span>
                <span class="n">population_to_change</span><span class="p">[</span><span class="n">proc</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
            <span class="n">population_to_change</span><span class="p">[</span><span class="n">proc</span><span class="p">]</span><span class="o">.</span><span class="n">update</span><span class="p">({</span> <span class="n">key</span><span class="p">:</span> <span class="mi">0</span>
                                                <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">combinations</span>
                                                <span class="k">if</span> <span class="n">key</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">population_to_change</span><span class="p">[</span><span class="n">proc</span><span class="p">]})</span>
        <span class="c1">## compute total per process</span>
        <span class="n">total_values</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">proc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">proc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                <span class="k">continue</span>
            <span class="n">total_values</span><span class="p">[</span><span class="n">proc</span><span class="p">]</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">population_to_change</span><span class="p">[</span><span class="n">proc</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">())</span>\
                                 <span class="k">if</span> <span class="n">proc</span> <span class="ow">in</span> <span class="n">population_to_change</span> <span class="k">else</span> <span class="mi">0</span>
        <span class="n">total</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">total</span><span class="p">,</span> <span class="o">*</span><span class="n">total_values</span><span class="o">.</span><span class="n">values</span><span class="p">())</span>

        <span class="c1"># any process with less than total ?</span>
        <span class="k">if</span> <span class="nb">any</span><span class="p">(</span><span class="n">value</span> <span class="o">&lt;</span> <span class="n">total</span> <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">total_values</span><span class="o">.</span><span class="n">values</span><span class="p">()):</span>
            <span class="k">for</span> <span class="n">proc</span><span class="p">,</span> <span class="n">compart</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">if</span> <span class="n">proc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                    <span class="k">continue</span>
                <span class="n">subtotal</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">population_to_change</span><span class="p">[</span><span class="n">proc</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">())</span>
                <span class="k">if</span> <span class="n">subtotal</span> <span class="o">&lt;</span> <span class="n">total</span><span class="p">:</span>
                    <span class="n">difference</span> <span class="o">=</span> <span class="n">total</span> <span class="o">-</span> <span class="n">subtotal</span>
                    <span class="n">available</span> <span class="o">=</span> <span class="p">[</span><span class="n">key</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">population_to_change</span><span class="p">[</span><span class="n">proc</span><span class="p">]</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>
                                 <span class="k">if</span> <span class="n">population_to_change</span><span class="p">[</span><span class="n">proc</span><span class="p">][</span><span class="n">key</span><span class="p">]</span> <span class="o">==</span> <span class="mi">0</span><span class="p">]</span>
                    <span class="k">if</span> <span class="n">remove</span><span class="p">:</span>
                        <span class="n">available</span> <span class="o">=</span> <span class="p">[</span><span class="n">key</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">available</span>
                                     <span class="k">if</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">compart</span><span class="o">.</span><span class="n">_content</span> <span class="ow">and</span>\
                                     <span class="n">compart</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">]</span>
                    <span class="k">if</span> <span class="ow">not</span> <span class="n">available</span><span class="p">:</span>
                        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;WARNING !!! initial populations for process </span><span class="si">{}</span><span class="s2"> is&quot;</span>
                              <span class="s2">&quot; less than total population </span><span class="si">{}</span><span class="s2"> and there is no&quot;</span>
                              <span class="s2">&quot; empty compartment to redistribute the&quot;</span>
                              <span class="s2">&quot; difference&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">proc</span><span class="p">,</span> <span class="n">subtotal</span><span class="p">))</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">nb</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">available</span><span class="p">)</span>
                        <span class="k">if</span> <span class="n">remove</span><span class="p">:</span>
                            <span class="n">pops</span> <span class="o">=</span> <span class="p">[</span><span class="n">compart</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">available</span><span class="p">]</span>
                            <span class="n">probas</span> <span class="o">=</span> <span class="p">[</span><span class="n">pop</span> <span class="o">/</span> <span class="nb">sum</span><span class="p">(</span><span class="n">pops</span><span class="p">)</span> <span class="k">for</span> <span class="n">pop</span> <span class="ow">in</span> <span class="n">pops</span><span class="p">]</span>
                        <span class="k">else</span><span class="p">:</span>
                            <span class="n">probas</span> <span class="o">=</span> <span class="p">[</span><span class="mi">1</span> <span class="o">/</span> <span class="n">nb</span><span class="p">]</span> <span class="o">*</span> <span class="n">nb</span>

                        <span class="n">amounts</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">multinomial</span><span class="p">(</span><span class="n">difference</span><span class="p">,</span> <span class="n">probas</span><span class="p">)</span>\
                                  <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">stochastic</span>\
                                  <span class="k">else</span> <span class="p">[</span><span class="n">difference</span> <span class="o">*</span> <span class="n">p</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">probas</span><span class="p">]</span>

                        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">amount</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">available</span><span class="p">,</span> <span class="n">amounts</span><span class="p">):</span>
                            <span class="n">population_to_change</span><span class="p">[</span><span class="n">proc</span><span class="p">][</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">amount</span></div>



<div class="viewcode-block" id="CompartProcessManager.add_population"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.add_population">[docs]</a>    <span class="k">def</span> <span class="nf">add_population</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population_spec</span><span class="p">,</span> <span class="n">init</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified population specification to the current</span>
<span class="sd">        CompartProcessManager. `population_spec` is a dictionary with</span>
<span class="sd">        process names as keys, each one associated with a dictionary</span>
<span class="sd">        (tuple of statevars) -&gt; population. If `init` is True, the compartment</span>
<span class="sd">        managers counts the initial value of the populations in each</span>
<span class="sd">        compartment.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">complement_population</span><span class="p">(</span><span class="n">population_spec</span><span class="p">)</span>
        <span class="c1"># add populations to appropriate compartments for each process</span>
        <span class="n">added</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">process</span><span class="p">,</span> <span class="n">spec</span> <span class="ow">in</span> <span class="n">population_spec</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="c1"># print(process, spec)</span>
            <span class="k">if</span> <span class="n">process</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                <span class="c1"># retrieve the group manager associated to the process</span>
                <span class="n">manager</span> <span class="o">=</span> <span class="bp">self</span><span class="p">[</span><span class="n">process</span><span class="p">]</span>
                <span class="c1"># retrieve the machine name (always here in compartment models)</span>
                <span class="n">machine_name</span> <span class="o">=</span> <span class="n">manager</span><span class="o">.</span><span class="n">state_machine</span><span class="o">.</span><span class="n">machine_name</span>
                <span class="c1"># locate the index of the statevar holding the state</span>
                <span class="c1"># of the state machine</span>
                <span class="n">index</span> <span class="o">=</span> <span class="n">manager</span><span class="o">.</span><span class="n">keys</span><span class="o">.</span><span class="n">index</span><span class="p">(</span><span class="n">machine_name</span><span class="p">)</span>\
                        <span class="k">if</span> <span class="n">machine_name</span> <span class="ow">in</span> <span class="n">manager</span><span class="o">.</span><span class="n">keys</span> <span class="k">else</span> <span class="kc">None</span>
                <span class="n">default_key</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="kc">None</span> <span class="k">for</span> <span class="n">_</span> <span class="ow">in</span> <span class="n">manager</span><span class="o">.</span><span class="n">keys</span><span class="p">)</span>
                <span class="n">added</span><span class="p">[</span><span class="n">process</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>
                <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">qty</span> <span class="ow">in</span> <span class="n">spec</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                    <span class="k">if</span> <span class="n">key</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">manager</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
                        <span class="n">new_comp</span> <span class="o">=</span> <span class="n">manager</span><span class="p">[</span><span class="n">default_key</span><span class="p">]</span><span class="o">.</span><span class="n">clone</span><span class="p">(</span><span class="n">population</span><span class="o">=</span><span class="n">qty</span><span class="p">)</span>
                        <span class="k">if</span> <span class="n">index</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                            <span class="n">new_comp</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">machine_name</span><span class="p">]</span> <span class="o">=</span> <span class="n">key</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>
                        <span class="n">new_comp</span><span class="o">.</span><span class="n">keys</span> <span class="o">=</span> <span class="n">key</span>
                        <span class="n">manager</span><span class="o">.</span><span class="n">_content</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">new_comp</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">manager</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">qty</span><span class="p">)</span>
                    <span class="n">added</span><span class="p">[</span><span class="n">process</span><span class="p">]</span> <span class="o">+=</span> <span class="n">qty</span>
        <span class="k">if</span> <span class="n">init</span><span class="p">:</span>
            <span class="n">manager</span><span class="o">.</span><span class="n">update_counts</span><span class="p">()</span>
        <span class="c1"># print(list(added.values()))</span>
        <span class="n">nb</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">added</span><span class="o">.</span><span class="n">values</span><span class="p">())</span>
        <span class="k">assert</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">nb</span><span class="p">)</span> <span class="o">&lt;=</span> <span class="mi">1</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">nb</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span> <span class="o">+=</span> <span class="n">nb</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span></div>

<div class="viewcode-block" id="CompartProcessManager.remove"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.remove">[docs]</a>    <span class="k">def</span> <span class="nf">remove</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">agents_or_population</span><span class="p">):</span>
        <span class="k">assert</span><span class="p">(</span><span class="n">agents_or_population</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;population&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">remove_population</span><span class="p">(</span><span class="n">agents_or_population</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span></div>


<div class="viewcode-block" id="CompartProcessManager.remove_all"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.remove_all">[docs]</a>    <span class="k">def</span> <span class="nf">remove_all</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove the whole population from the current</span>
<span class="sd">        CompartProcessManager.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># for process, comp in self._content.items():</span>
        <span class="c1">#     if process not in self.no_compart:</span>
        <span class="c1">#         # print(process, spec)</span>
        <span class="c1">#         comp.remove(comp.population)</span>
        <span class="c1"># self.statevars.population = 0</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">remove_randomly</span><span class="p">(</span><span class="n">proba</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span></div>

<div class="viewcode-block" id="CompartProcessManager.remove_population"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.remove_population">[docs]</a>    <span class="k">def</span> <span class="nf">remove_population</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population_spec</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove the specified population spec from the current</span>
<span class="sd">        CompartProcessManager.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">init_pop</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">complement_population</span><span class="p">(</span><span class="n">population_spec</span><span class="p">,</span> <span class="n">remove</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="c1"># print(&#39;&gt;&#39;*10)</span>
        <span class="c1"># print(population_spec)</span>
        <span class="c1"># print(&#39;&lt;&#39;*10)</span>
        <span class="n">removed</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">process</span><span class="p">,</span> <span class="n">spec</span> <span class="ow">in</span> <span class="n">population_spec</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">process</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                <span class="c1"># print(process, spec)</span>
                <span class="n">manager</span> <span class="o">=</span> <span class="bp">self</span><span class="p">[</span><span class="n">process</span><span class="p">]</span>
                <span class="n">removed</span><span class="p">[</span><span class="n">process</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>
                <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">qty</span> <span class="ow">in</span> <span class="n">spec</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                    <span class="k">if</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">manager</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
                        <span class="n">nb_removed</span> <span class="o">=</span> <span class="n">manager</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">qty</span><span class="p">)</span>
                        <span class="n">removed</span><span class="p">[</span><span class="n">process</span><span class="p">]</span> <span class="o">+=</span> <span class="n">nb_removed</span>
        <span class="n">nb</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">removed</span><span class="o">.</span><span class="n">values</span><span class="p">())</span>
        <span class="k">assert</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">nb</span><span class="p">)</span> <span class="o">&lt;=</span> <span class="mi">1</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">nb</span><span class="p">:</span>
            <span class="n">nb_removed</span> <span class="o">=</span> <span class="n">nb</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span> <span class="o">-=</span> <span class="n">nb_removed</span>
        <span class="k">if</span> <span class="n">init_pop</span> <span class="o">&lt;</span> <span class="n">nb_removed</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">init_pop</span><span class="p">,</span> <span class="n">population_spec</span><span class="p">,</span> <span class="n">removed</span><span class="p">,</span>  <span class="n">nb_removed</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span><span class="p">)</span></div>

<div class="viewcode-block" id="CompartProcessManager.remove_randomly"><a class="viewcode-back" href="../../../../emulsion.agent.managers.html#emulsion.agent.managers.compart_process_manager.CompartProcessManager.remove_randomly">[docs]</a>    <span class="k">def</span> <span class="nf">remove_randomly</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">proba</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">amount</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">process</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove random amounts of populations from this ProcessManager. If</span>
<span class="sd">        `amount` is not None, a multinomial sampling is performed for</span>
<span class="sd">        each process. Otherwise: `proba` can be either a probability</span>
<span class="sd">        or a dictionary. In that case, the `process` parameter</span>
<span class="sd">        indicates the name of the process grouping which drives the</span>
<span class="sd">        probabilities, and the keys must be those of the</span>
<span class="sd">        grouping. Selected quantities are removed and returned by the</span>
<span class="sd">        method.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">to_remove</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="n">total</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="n">amount</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">proc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">if</span> <span class="n">name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span><span class="p">:</span>
                    <span class="n">keys</span><span class="p">,</span> <span class="n">probs</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="p">[(</span><span class="n">key</span><span class="p">,</span> <span class="n">comp</span><span class="o">.</span><span class="n">population</span><span class="p">)</span>
                                        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">comp</span> <span class="ow">in</span> <span class="n">proc</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">()])</span>
                    <span class="n">s</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">probs</span><span class="p">)</span>
                    <span class="n">probas</span> <span class="o">=</span> <span class="p">[</span><span class="n">p</span> <span class="o">/</span> <span class="n">s</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">probs</span><span class="p">]</span>
                    <span class="n">amounts</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">multinomial</span><span class="p">(</span><span class="n">amount</span><span class="p">,</span> <span class="n">probas</span><span class="p">)</span>
                    <span class="n">to_remove</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="nb">zip</span><span class="p">(</span><span class="n">keys</span><span class="p">,</span> <span class="n">amounts</span><span class="p">))</span>
                    <span class="c1"># print(to_remove)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">remove_population</span><span class="p">(</span><span class="n">to_remove</span><span class="p">)</span>
            <span class="k">return</span> <span class="n">to_remove</span>

        <span class="k">if</span> <span class="n">process</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">to_remove</span><span class="p">[</span><span class="n">process</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
            <span class="n">total</span> <span class="o">=</span> <span class="mi">0</span>
            <span class="c1"># print(self._content, process, name, self.no_compart)</span>
            <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">comp</span> <span class="ow">in</span> <span class="bp">self</span><span class="p">[</span><span class="n">process</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="n">pop</span> <span class="o">=</span> <span class="n">comp</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span>
                <span class="k">if</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">proba</span><span class="p">:</span>
                    <span class="n">n</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">binomial</span><span class="p">(</span><span class="n">pop</span><span class="p">,</span> <span class="n">proba</span><span class="p">[</span><span class="n">key</span><span class="p">])</span>
                    <span class="n">to_remove</span><span class="p">[</span><span class="n">process</span><span class="p">][</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">n</span>
                    <span class="n">total</span> <span class="o">+=</span> <span class="n">n</span>
        <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">proc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_compart</span> <span class="ow">or</span> <span class="n">name</span> <span class="o">==</span> <span class="n">process</span><span class="p">:</span>
                <span class="k">continue</span>
            <span class="k">if</span> <span class="n">total</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">to_remove</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
                <span class="n">total</span> <span class="o">=</span> <span class="mi">0</span>
                <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">comp</span> <span class="ow">in</span> <span class="n">proc</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                    <span class="n">pop</span> <span class="o">=</span> <span class="n">comp</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span>
                    <span class="n">n</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">binomial</span><span class="p">(</span><span class="n">pop</span><span class="p">,</span> <span class="n">proba</span><span class="p">)</span>
                    <span class="n">to_remove</span><span class="p">[</span><span class="n">name</span><span class="p">][</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">n</span>
                    <span class="n">total</span> <span class="o">+=</span> <span class="n">n</span>
                <span class="k">continue</span>
            <span class="n">keys</span><span class="p">,</span> <span class="n">pops</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="p">[(</span><span class="n">key</span><span class="p">,</span> <span class="n">comp</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span><span class="p">)</span>
                               <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">comp</span> <span class="ow">in</span> <span class="bp">self</span><span class="p">[</span><span class="n">name</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">()])</span>
            <span class="n">total_pop</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">pops</span><span class="p">)</span>
            <span class="n">probas</span> <span class="o">=</span> <span class="p">[</span> <span class="n">n</span> <span class="o">/</span> <span class="n">total_pop</span> <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="n">pops</span><span class="p">]</span>
            <span class="n">qties</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">multinomial</span><span class="p">(</span><span class="n">total</span><span class="p">,</span> <span class="n">probas</span><span class="p">)</span>
            <span class="n">to_remove</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="nb">zip</span><span class="p">(</span><span class="n">keys</span><span class="p">,</span> <span class="n">qties</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">remove_population</span><span class="p">(</span><span class="n">to_remove</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">to_remove</span></div>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">counts</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return a pandas DataFrame containing counts of each process if existing.</span>
<span class="sd">        TODO: column steps need to be with one of process</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">res</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">comp</span> <span class="ow">in</span> <span class="bp">self</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">res</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">comp</span><span class="o">.</span><span class="n">counts</span><span class="p">)</span>
            <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
                <span class="k">pass</span>
            <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">exc</span><span class="p">:</span>
                <span class="k">raise</span> <span class="n">exc</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">keep_history</span><span class="p">:</span>
            <span class="n">res</span><span class="o">.</span><span class="n">update</span><span class="p">({</span>
                <span class="s1">&#39;level&#39;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">level</span><span class="p">,</span>
                <span class="s1">&#39;agent_id&#39;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">agid</span><span class="p">,</span>
                <span class="c1"># &#39;population&#39;: self.population}</span>
            <span class="p">})</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">level</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">outputs</span> <span class="ow">and</span>\
               <span class="s1">&#39;extra_vars&#39;</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">outputs</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">level</span><span class="p">]:</span>
                <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">outputs</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">level</span><span class="p">][</span><span class="s1">&#39;extra_vars&#39;</span><span class="p">]:</span>
                    <span class="k">if</span> <span class="n">name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">parameters</span><span class="p">:</span>
                        <span class="n">res</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_model_value</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="k">try</span><span class="p">:</span>
                            <span class="n">value</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_information</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
                        <span class="k">except</span> <span class="n">StateVarNotFoundException</span><span class="p">:</span>
                            <span class="n">value</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">nan</span>
                        <span class="n">res</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span>
        <span class="k">return</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">res</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../../index.html">Documentation overview</a><ul>
  <li><a href="../../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>